# How to contribute

First off, thanks for taking the time to contribute! We're pleased to have you on board! :tada:
We understand that contributing to a project may be daunting at first but hopefully this guide
will give you a friendly introduction and help you on your way.

## Getting started

A simple way to get started is to fork the repository, create a bug/feature branch, write some
code to fix the problem or add the feature and then submit a pull request. This allows core developers
to review, comment and offer advice on your changes with ease.

  - Fork the repository
  - Create a bug or feature branch
  - Submit a pull request

### Issues to solve

If you are keen to contribute but are not sure exactly where to begin it is a good idea
to take a peak at the [Projects](https://github.com/informatics-lab/forest/projects) page.
Projects contain lists of issues that are hot topics at the moment. Including features
scheduled for the next release, the highest priority bugs and notes describing ideas that
have yet to coalesce into a concrete issue. Contributions to items on the project board
is a good way to attract help from other developers since they are likely to be already
thinking about the problem and be keen to have some help.

### Developer guide

Please check out the [Developer Guide](https://forest-informaticslab.readthedocs.io/en/latest/guide.html) in the docs
for a more detailed and up to date description of how to build, test and run the code.

### Submitting a pull request

It's also useful to describe in the pull request the following pieces of information

  - The problem it solves, e.g. fix memory leak or add button to a widget
  - The nature of the solution, technical details are welcome
  - Include the relevant unit/integration tests
  - Documentation to help users/developers on their way
  
Tests/docs are encouraged to prevent future developments from breaking your changes
and to allow users to learn how to use the feature.


## Contact

We don't have a message board or mailing list so contact is only possible through comments on issues
and pull requests at the moment.
